/*
 * POSIX dirname utility
 * Taylor Gurney, 2024.
 * Public domain.
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "util.h"

static char* argv0;

static void usage(void) {
    fputs("usage: ", stderr);
    fputs(argv0, stderr);
    fputs(" <string>\n", stderr);
    exit(1);
}

static size_t rmslashs(char* s, size_t len) {
    /* remove all trailing slash */
    while (len && (s[len - 1] == DIRCHR)) {
        len--;
        s[len] = '\0';
    }
    if (!len) {
        puts(DIRSTR);
        exit(0);
    }
    return len;
}

int main(int argc, char* argv[]) {
    size_t len;
    char* last = NULL;
    char* s;
    argv0 = argv[0];
    shift();
    dashdash();
    if (argc != 1) {
        usage();
    }
    s = *argv;
    len = strlen(s);
    if (!len) {
        puts(".");
        return 0;
    }
    len = rmslashs(s, len);
    /* return '.' if no slashes left */
    last = strrchr(s, DIRCHR);
    if (last == NULL) {
        puts(".");
        return 0;
    }
    *last = '\0';
    len = strlen(s);
    rmslashs(s, len);
    puts(s);
    return 0;
}
