#ifndef STRTOU32_H
#define STRTOU32_H

#include "u32.h"
#include "u8.h"

static int strtou32(const char* s, u32* out, int neg) {
    const char* ptr = s;
    u32 tmp = 0;
    u32 oldtmp = 0;
    int flip = 0;
    u8 digit = 0;
    unsigned int base = 10;
    if (!s) {
        return -1;
    }
    /* skip sign */
    if (*ptr == '+') {
        ptr++;
    } else if (*ptr == '-') {
        if (!neg) {
            return -1;
        }
        flip = 1;
        ptr++;
    }
    /* check if hex */
    if (*ptr == '0' && *(ptr+1) == 'x') {
        base = 16;
        ptr += 2;
    }
    /* ensure there is something left */
    if (!*ptr) {
        return -1;
    }
    /* skip leading 0 */
    while (*ptr == '0') {
        ptr++;
    }
    for (; *ptr; ptr++) {
        oldtmp = tmp;
        tmp *= base;
        digit = numtab[(u8)(*ptr)];
        if (digit > 16 || (base == 10 && digit > 10)) {
            return -1;
        }
        tmp += digit;
        if (oldtmp > tmp) {
            /* too big */
            return -1;
        }
    }
    if (flip) {
        /* two's complement negation */
        tmp = ~tmp;
        tmp += 1;
    }
    *out = tmp;
    return 0;
}

#endif /* STRTOU32_H */
