#ifndef UTIL_H
#define UTIL_H

#if defined(__unix__) || defined(_POSIX_VERSION) || defined(__APPLE__)
#define DIRCHR '/'
#define DIRSTR "/"
#else
/* Windows, DOS */
#define DIRCHR '\\'
#define DIRSTR "\\"
#endif

#define shift() ((void)(argc--, argv++))

#define dashdash() (\
    (argc && argv[0][0] == '-' && argv[0][1] != '\0') ? (\
        (argv[0][1] == '-' && argv[0][2] == '\0') ?\
            shift() : usage()\
    ) : (void)0\
)

#define min(a, b) (((a) < (b)) ? (a) : (b))
#define bintoprint(c) (((c) < 0x20 || (c) >= 0x7f) ? 0x2e : (c))

#define BANNED (sorry_this_is_banned)
#undef strcpy
#define strcpy(a, b) BANNED
#undef strcat
#define strcat(a, b) BANNED
#undef strncpy
#define strncpy(a, b, c) BANNED
#undef strncat
#define strncat(a, b, c) BANNED
#undef strtok
#define strtok(a, b) BANNED
#undef strtok_r
#define strtok_r(a, b, c) BANNED
#undef printf
#define printf() BANNED
#undef scanf
#define scanf() BANNED
#undef sprintf
#define sprintf() BANNED
#undef snprintf
#define snprintf() BANNED
#undef vsprintf
#define vsprintf(a, b, c) BANNED
#undef gmtime
#define gmtime(t) BANNED
#undef localtime
#define localtime(t) BANNED
#undef ctime
#define ctime(t) BANNED
#undef ctime_r
#define ctime_r(t, buf) BANNED
#undef asctime
#define asctime(t) BANNED
#undef asctime_r
#define asctime_r(t, buf) BANNED
#undef wchar_t
#define wchar_t BANNED
#undef isalnum
#define isalnum(c) BANNED
#undef isalpha
#define isalpha(c) BANNED
#undef iscntrl
#define iscntrl(c) BANNED
#undef isdigit
#define isdigit(c) BANNED
#undef isgraph
#define isgraph(c) BANNED
#undef islower
#define islower(c) BANNED
#undef isprint
#define isprint(c) BANNED
#undef ispunct
#define ispunct(c) BANNED
#undef isspace
#define isspace(c) BANNED
#undef isupper
#define isupper(c) BANNED
#undef isxdigit
#define isxdigit(c) BANNED
#undef tolower
#define tolower(c) BANNED
#undef toupper
#define toupper(c) BANNED
#undef fscanf
#define fscanf() BANNED
#undef fprintf
#define fprintf() BANNED
#undef sscanf
#define sscanf() BANNED
#undef vfprintf
#define vfprintf(a, b, c) BANNED
#undef gets
#define gets(s) BANNED
#undef ungetc
#define ungetc(c) BANNED
#undef strtod
#define strtod(a, b) BANNED
#undef stdtol
#define strtol(a, b, c) BANNED
#undef strtoul
#define strtoul(a, b, c) BANNED
#undef rand
#define rand() BANNED
#undef srand
#define srand(s) BANNED
#undef calloc
#define calloc(a, b) BANNED
#undef free
#define free(a) BANNED
#undef malloc
#define malloc(a) BANNED
#undef realloc
#define realloc(a, b) BANNED
#undef atexit
#define atexit(a) BANNED
#undef bsearch
#define bsearch(a,b,c,d,e) BANNED
#undef qsort
#define qsort(a,b,c,d,e) BANNED
#undef mblen
#define mblen(a,b) BANNED
#undef mbtowc
#define mbtowc(a,b,c) BANNED
#undef wctomb
#define wctomb(a,b) BANNED
#undef mbstowcs
#define mbstowcs(a,b,c) BANNED
#undef wcstombs
#define wcstombs(a,b,c) BANNED
#undef strcoll
#define strcoll(a,b) BANNED
#undef strxfrm
#define strxfrm(a,b,c) BANNED
#undef strcspn
#define strcspn(a,b) BANNED
#undef strpbrk
#define strpbrk(a,b) BANNED

/* get option argument */
#define optarg() (\
    (argv[0][1]) ?\
        (nextarg = 1, &argv[0][1]) : (\
        (argc > 1) ?\
            (nextarg = 1, shift(), argv_[1]) :\
            (usage(), abort(), (char*)NULL)\
        )\
)
#endif /* UTIL_H */
